]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib-functions.sh
test-lib-functions: introduce the 'test_set_port' helper function
[thirdparty/git.git] / t / test-lib-functions.sh
CommitLineData
c74c7203
JN
1# Library of functions shared by all tests scripts, included by
2# test-lib.sh.
12a29b1a
TR
3#
4# Copyright (c) 2005 Junio C Hamano
5#
6# This program is free software: you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation, either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program. If not, see http://www.gnu.org/licenses/ .
18
19# The semantics of the editor variables are that of invoking
20# sh -c "$EDITOR \"$@\"" files ...
21#
22# If our trash directory contains shell metacharacters, they will be
23# interpreted if we just set $EDITOR directly, so do a little dance with
24# environment variables to work around this.
25#
26# In particular, quoting isn't enough, as the path may contain the same quote
27# that we're using.
28test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33}
34
5d9fc888
TG
35test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38}
39
12a29b1a
TR
40test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
991eb4fc
SB
45 if (n == 2) return "FAINT";
46 if (n == 3) return "ITALIC";
097b681b 47 if (n == 7) return "REVERSE";
12a29b1a
TR
48 if (n == 30) return "BLACK";
49 if (n == 31) return "RED";
50 if (n == 32) return "GREEN";
51 if (n == 33) return "YELLOW";
52 if (n == 34) return "BLUE";
53 if (n == 35) return "MAGENTA";
54 if (n == 36) return "CYAN";
55 if (n == 37) return "WHITE";
56 if (n == 40) return "BLACK";
57 if (n == 41) return "BRED";
58 if (n == 42) return "BGREEN";
59 if (n == 43) return "BYELLOW";
60 if (n == 44) return "BBLUE";
61 if (n == 45) return "BMAGENTA";
62 if (n == 46) return "BCYAN";
63 if (n == 47) return "BWHITE";
64 }
65 {
66 while (match($0, /\033\[[0-9;]*m/) != 0) {
67 printf "%s<", substr($0, 1, RSTART-1);
68 codes = substr($0, RSTART+2, RLENGTH-3);
69 if (length(codes) == 0)
70 printf "%s", name(0)
71 else {
72 n = split(codes, ary, ";");
73 sep = "";
74 for (i = 1; i <= n; i++) {
75 printf "%s%s", sep, name(ary[i]);
76 sep = ";"
77 }
78 }
79 printf ">";
80 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81 }
82 print
83 }
84 '
85}
86
b249e39f
JH
87lf_to_nul () {
88 perl -pe 'y/\012/\000/'
89}
90
12a29b1a 91nul_to_q () {
94221d22 92 perl -pe 'y/\000/Q/'
12a29b1a
TR
93}
94
95q_to_nul () {
94221d22 96 perl -pe 'y/Q/\000/'
12a29b1a
TR
97}
98
99q_to_cr () {
100 tr Q '\015'
101}
102
103q_to_tab () {
104 tr Q '\011'
105}
106
250b3c6c
JH
107qz_to_tab_space () {
108 tr QZ '\011\040'
12a29b1a
TR
109}
110
111append_cr () {
112 sed -e 's/$/Q/' | tr Q '\015'
113}
114
115remove_cr () {
116 tr '\015' Q | sed -e 's/Q$//'
117}
118
119# In some bourne shell implementations, the "unset" builtin returns
120# nonzero status when a variable to be unset was not set in the first
121# place.
122#
123# Use sane_unset when that should not be considered an error.
124
125sane_unset () {
126 unset "$@"
127 return 0
128}
129
130test_tick () {
131 if test -z "${test_tick+set}"
132 then
133 test_tick=1112911993
134 else
135 test_tick=$(($test_tick + 60))
136 fi
137 GIT_COMMITTER_DATE="$test_tick -0700"
138 GIT_AUTHOR_DATE="$test_tick -0700"
139 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
140}
141
59210dd5 142# Stop execution and start a shell. This is useful for debugging tests.
12a29b1a
TR
143#
144# Be sure to remove all invocations of this command before submitting.
145
146test_pause () {
59210dd5 147 "$SHELL_PATH" <&6 >&5 2>&7
12a29b1a
TR
148}
149
84243646
EN
150# Wrap git with a debugger. Adding this to a command can make it easier
151# to understand what is going on in a failing test.
6a94088c 152#
84243646
EN
153# Examples:
154# debug git checkout master
155# debug --debugger=nemiver git $ARGS
156# debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
6a94088c 157debug () {
84243646
EN
158 case "$1" in
159 -d)
160 GIT_DEBUGGER="$2" &&
161 shift 2
162 ;;
163 --debugger=*)
164 GIT_DEBUGGER="${1#*=}" &&
165 shift 1
166 ;;
167 *)
168 GIT_DEBUGGER=1
169 ;;
170 esac &&
171 GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
6a94088c
JS
172}
173
6f94351b
SB
174# Call test_commit with the arguments
175# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
12a29b1a
TR
176#
177# This will commit a file with the given contents and the given commit
4c994194 178# message, and tag the resulting commit with the given tag name.
12a29b1a 179#
4c994194 180# <file>, <contents>, and <tag> all default to <message>.
6f94351b
SB
181#
182# If the first argument is "-C", the second argument is used as a path for
183# the git invocations.
12a29b1a
TR
184
185test_commit () {
9a0231b3 186 notick= &&
5ed75e2a 187 signoff= &&
6f94351b 188 indir= &&
5ed75e2a
MV
189 while test $# != 0
190 do
191 case "$1" in
192 --notick)
193 notick=yes
194 ;;
195 --signoff)
196 signoff="$1"
197 ;;
6f94351b
SB
198 -C)
199 indir="$2"
200 shift
201 ;;
5ed75e2a
MV
202 *)
203 break
204 ;;
205 esac
9a0231b3 206 shift
5ed75e2a 207 done &&
6f94351b 208 indir=${indir:+"$indir"/} &&
9a0231b3 209 file=${2:-"$1.t"} &&
6f94351b
SB
210 echo "${3-$1}" > "$indir$file" &&
211 git ${indir:+ -C "$indir"} add "$file" &&
9a0231b3
JH
212 if test -z "$notick"
213 then
214 test_tick
215 fi &&
6f94351b
SB
216 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
217 git ${indir:+ -C "$indir"} tag "${4:-$1}"
12a29b1a
TR
218}
219
220# Call test_merge with the arguments "<message> <commit>", where <commit>
221# can be a tag pointing to the commit-to-merge.
222
223test_merge () {
224 test_tick &&
225 git merge -m "$1" "$2" &&
226 git tag "$1"
227}
228
229# This function helps systems where core.filemode=false is set.
230# Use it instead of plain 'chmod +x' to set or unset the executable bit
231# of a file in the working directory and add it to the index.
232
233test_chmod () {
234 chmod "$@" &&
235 git update-index --add "--chmod=$@"
236}
237
73de1c93
CC
238# Get the modebits from a file.
239test_modebits () {
240 ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
241}
242
12a29b1a
TR
243# Unset a configuration variable, but don't fail if it doesn't exist.
244test_unconfig () {
5fafc07f
JK
245 config_dir=
246 if test "$1" = -C
247 then
248 shift
249 config_dir=$1
250 shift
251 fi
252 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
12a29b1a
TR
253 config_status=$?
254 case "$config_status" in
255 5) # ok, nothing to unset
256 config_status=0
257 ;;
258 esac
259 return $config_status
260}
261
262# Set git config, automatically unsetting it after the test is over.
263test_config () {
5fafc07f
JK
264 config_dir=
265 if test "$1" = -C
266 then
267 shift
268 config_dir=$1
269 shift
270 fi
271 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
272 git ${config_dir:+-C "$config_dir"} config "$@"
12a29b1a
TR
273}
274
275test_config_global () {
276 test_when_finished "test_unconfig --global '$1'" &&
277 git config --global "$@"
278}
279
280write_script () {
281 {
282 echo "#!${2-"$SHELL_PATH"}" &&
283 cat
284 } >"$1" &&
285 chmod +x "$1"
286}
287
288# Use test_set_prereq to tell that a particular prerequisite is available.
289# The prerequisite can later be checked for in two ways:
290#
291# - Explicitly using test_have_prereq.
292#
293# - Implicitly by specifying the prerequisite tag in the calls to
294# test_expect_{success,failure,code}.
295#
296# The single parameter is the prerequisite tag (a simple word, in all
297# capital letters by convention).
298
7d0ee47c
JS
299test_unset_prereq () {
300 ! test_have_prereq "$1" ||
301 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
302}
303
12a29b1a 304test_set_prereq () {
7d0ee47c
JS
305 case "$1" in
306 !*)
307 test_unset_prereq "${1#!}"
308 ;;
309 *)
310 satisfied_prereq="$satisfied_prereq$1 "
311 ;;
312 esac
12a29b1a 313}
f3cfc3b2 314satisfied_prereq=" "
04083f27
JH
315lazily_testable_prereq= lazily_tested_prereq=
316
317# Usage: test_lazy_prereq PREREQ 'script'
318test_lazy_prereq () {
319 lazily_testable_prereq="$lazily_testable_prereq$1 "
320 eval test_prereq_lazily_$1=\$2
321}
322
323test_run_lazy_prereq_ () {
324 script='
325mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
326(
327 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
328)'
329 say >&3 "checking prerequisite: $1"
330 say >&3 "$script"
331 test_eval_ "$script"
332 eval_ret=$?
333 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
334 if test "$eval_ret" = 0; then
335 say >&3 "prerequisite $1 ok"
336 else
337 say >&3 "prerequisite $1 not satisfied"
338 fi
339 return $eval_ret
340}
12a29b1a
TR
341
342test_have_prereq () {
343 # prerequisites can be concatenated with ','
344 save_IFS=$IFS
345 IFS=,
346 set -- $*
347 IFS=$save_IFS
348
349 total_prereq=0
350 ok_prereq=0
351 missing_prereq=
352
353 for prerequisite
354 do
bdccd3c1
JK
355 case "$prerequisite" in
356 !*)
357 negative_prereq=t
358 prerequisite=${prerequisite#!}
359 ;;
360 *)
361 negative_prereq=
362 esac
363
04083f27
JH
364 case " $lazily_tested_prereq " in
365 *" $prerequisite "*)
366 ;;
367 *)
368 case " $lazily_testable_prereq " in
369 *" $prerequisite "*)
370 eval "script=\$test_prereq_lazily_$prerequisite" &&
371 if test_run_lazy_prereq_ "$prerequisite" "$script"
372 then
373 test_set_prereq $prerequisite
374 fi
375 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
376 esac
377 ;;
378 esac
379
12a29b1a 380 total_prereq=$(($total_prereq + 1))
f3cfc3b2 381 case "$satisfied_prereq" in
12a29b1a 382 *" $prerequisite "*)
bdccd3c1
JK
383 satisfied_this_prereq=t
384 ;;
385 *)
386 satisfied_this_prereq=
387 esac
388
389 case "$satisfied_this_prereq,$negative_prereq" in
390 t,|,t)
12a29b1a
TR
391 ok_prereq=$(($ok_prereq + 1))
392 ;;
393 *)
bdccd3c1
JK
394 # Keep a list of missing prerequisites; restore
395 # the negative marker if necessary.
396 prerequisite=${negative_prereq:+!}$prerequisite
12a29b1a
TR
397 if test -z "$missing_prereq"
398 then
399 missing_prereq=$prerequisite
400 else
401 missing_prereq="$prerequisite,$missing_prereq"
402 fi
403 esac
404 done
405
406 test $total_prereq = $ok_prereq
407}
408
409test_declared_prereq () {
410 case ",$test_prereq," in
411 *,$1,*)
412 return 0
413 ;;
414 esac
415 return 1
416}
417
d93d5d51
JH
418test_verify_prereq () {
419 test -z "$test_prereq" ||
420 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
165293af 421 BUG "'$test_prereq' does not look like a prereq"
d93d5d51
JH
422}
423
12a29b1a 424test_expect_failure () {
ae75342c 425 test_start_
12a29b1a
TR
426 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
427 test "$#" = 2 ||
165293af 428 BUG "not 2 or 3 parameters to test-expect-failure"
d93d5d51 429 test_verify_prereq
12a29b1a
TR
430 export test_prereq
431 if ! test_skip "$@"
432 then
433 say >&3 "checking known breakage: $2"
434 if test_run_ "$2" expecting_failure
435 then
436 test_known_broken_ok_ "$1"
437 else
438 test_known_broken_failure_ "$1"
439 fi
440 fi
ae75342c 441 test_finish_
12a29b1a
TR
442}
443
444test_expect_success () {
ae75342c 445 test_start_
12a29b1a
TR
446 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
447 test "$#" = 2 ||
165293af 448 BUG "not 2 or 3 parameters to test-expect-success"
d93d5d51 449 test_verify_prereq
12a29b1a
TR
450 export test_prereq
451 if ! test_skip "$@"
452 then
453 say >&3 "expecting success: $2"
454 if test_run_ "$2"
455 then
456 test_ok_ "$1"
457 else
458 test_failure_ "$@"
459 fi
460 fi
ae75342c 461 test_finish_
12a29b1a
TR
462}
463
464# test_external runs external test scripts that provide continuous
465# test output about their progress, and succeeds/fails on
466# zero/non-zero exit code. It outputs the test output on stdout even
467# in non-verbose mode, and announces the external script with "# run
468# <n>: ..." before running it. When providing relative paths, keep in
469# mind that all scripts run in "trash directory".
470# Usage: test_external description command arguments...
471# Example: test_external 'Perl API' perl ../path/to/test.pl
472test_external () {
473 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
474 test "$#" = 3 ||
165293af 475 BUG "not 3 or 4 parameters to test_external"
12a29b1a
TR
476 descr="$1"
477 shift
d93d5d51 478 test_verify_prereq
12a29b1a
TR
479 export test_prereq
480 if ! test_skip "$descr" "$@"
481 then
482 # Announce the script to reduce confusion about the
483 # test output that follows.
484 say_color "" "# run $test_count: $descr ($*)"
485 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
486 # to be able to use them in script
487 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
488 # Run command; redirect its stderr to &4 as in
489 # test_run_, but keep its stdout on our stdout even in
490 # non-verbose mode.
491 "$@" 2>&4
9e8f8dea 492 if test "$?" = 0
12a29b1a
TR
493 then
494 if test $test_external_has_tap -eq 0; then
495 test_ok_ "$descr"
496 else
497 say_color "" "# test_external test $descr was ok"
498 test_success=$(($test_success + 1))
499 fi
500 else
501 if test $test_external_has_tap -eq 0; then
502 test_failure_ "$descr" "$@"
503 else
504 say_color error "# test_external test $descr failed: $@"
505 test_failure=$(($test_failure + 1))
506 fi
507 fi
508 fi
509}
510
511# Like test_external, but in addition tests that the command generated
512# no output on stderr.
513test_external_without_stderr () {
514 # The temporary file has no (and must have no) security
515 # implications.
516 tmp=${TMPDIR:-/tmp}
517 stderr="$tmp/git-external-stderr.$$.tmp"
518 test_external "$@" 4> "$stderr"
9e8f8dea 519 test -f "$stderr" || error "Internal error: $stderr disappeared."
12a29b1a
TR
520 descr="no stderr: $1"
521 shift
522 say >&3 "# expecting no stderr from previous command"
9e8f8dea
DA
523 if test ! -s "$stderr"
524 then
12a29b1a
TR
525 rm "$stderr"
526
527 if test $test_external_has_tap -eq 0; then
528 test_ok_ "$descr"
529 else
530 say_color "" "# test_external_without_stderr test $descr was ok"
531 test_success=$(($test_success + 1))
532 fi
533 else
9e8f8dea
DA
534 if test "$verbose" = t
535 then
536 output=$(echo; echo "# Stderr is:"; cat "$stderr")
12a29b1a
TR
537 else
538 output=
539 fi
540 # rm first in case test_failure exits.
541 rm "$stderr"
542 if test $test_external_has_tap -eq 0; then
543 test_failure_ "$descr" "$@" "$output"
544 else
545 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
546 test_failure=$(($test_failure + 1))
547 fi
548 fi
549}
550
551# debugging-friendly alternatives to "test [-f|-d|-e]"
552# The commands test the existence or non-existence of $1. $2 can be
553# given to provide a more precise diagnosis.
554test_path_is_file () {
9e8f8dea 555 if ! test -f "$1"
12a29b1a 556 then
de248e92 557 echo "File $1 doesn't exist. $2"
12a29b1a
TR
558 false
559 fi
560}
561
562test_path_is_dir () {
9e8f8dea 563 if ! test -d "$1"
12a29b1a 564 then
de248e92 565 echo "Directory $1 doesn't exist. $2"
12a29b1a
TR
566 false
567 fi
568}
569
7e9055bb
EN
570test_path_exists () {
571 if ! test -e "$1"
572 then
573 echo "Path $1 doesn't exist. $2"
574 false
575 fi
576}
577
0be7d9b7
JL
578# Check if the directory exists and is empty as expected, barf otherwise.
579test_dir_is_empty () {
580 test_path_is_dir "$1" &&
581 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
582 then
583 echo "Directory '$1' is not empty, it contains:"
584 ls -la "$1"
585 return 1
586 fi
587}
588
12a29b1a 589test_path_is_missing () {
9e8f8dea 590 if test -e "$1"
12a29b1a
TR
591 then
592 echo "Path exists:"
593 ls -ld "$1"
9e8f8dea
DA
594 if test $# -ge 1
595 then
12a29b1a
TR
596 echo "$*"
597 fi
598 false
599 fi
600}
601
602# test_line_count checks that a file has the number of lines it
603# ought to. For example:
604#
605# test_expect_success 'produce exactly one line of output' '
606# do something >output &&
607# test_line_count = 1 output
608# '
609#
610# is like "test $(wc -l <output) = 1" except that it passes the
611# output through when the number of lines is wrong.
612
613test_line_count () {
614 if test $# != 3
615 then
165293af 616 BUG "not 3 parameters to test_line_count"
12a29b1a
TR
617 elif ! test $(wc -l <"$3") "$1" "$2"
618 then
619 echo "test_line_count: line count for $3 !$1 $2"
620 cat "$3"
621 return 1
622 fi
623}
624
bbfe5302
LS
625# Returns success if a comma separated string of keywords ($1) contains a
626# given keyword ($2).
627# Examples:
628# `list_contains "foo,bar" bar` returns 0
629# `list_contains "foo" bar` returns 1
630
631list_contains () {
632 case ",$1," in
633 *,$2,*)
634 return 0
635 ;;
636 esac
637 return 1
638}
639
12a29b1a
TR
640# This is not among top-level (test_expect_success | test_expect_failure)
641# but is a prefix that can be used in the test script, like:
642#
643# test_expect_success 'complain and die' '
644# do something &&
645# do something else &&
646# test_must_fail git checkout ../outerspace
647# '
648#
649# Writing this as "! git checkout ../outerspace" is wrong, because
650# the failure could be due to a segv. We want a controlled failure.
12e31a6b
SG
651#
652# Accepts the following options:
653#
654# ok=<signal-name>[,<...>]:
655# Don't treat an exit caused by the given signal as error.
656# Multiple signals can be specified as a comma separated list.
657# Currently recognized signal names are: sigpipe, success.
658# (Don't use 'success', use 'test_might_fail' instead.)
12a29b1a
TR
659
660test_must_fail () {
bbfe5302
LS
661 case "$1" in
662 ok=*)
663 _test_ok=${1#ok=}
664 shift
665 ;;
666 *)
667 _test_ok=
668 ;;
669 esac
a5bf824f 670 "$@" 2>&7
12a29b1a 671 exit_code=$?
bbfe5302
LS
672 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
673 then
03aa3783 674 echo >&4 "test_must_fail: command succeeded: $*"
12a29b1a 675 return 1
2472448c 676 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
8bf4becf
LS
677 then
678 return 0
bbfe5302
LS
679 elif test $exit_code -gt 129 && test $exit_code -le 192
680 then
03aa3783 681 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
12a29b1a 682 return 1
bbfe5302
LS
683 elif test $exit_code -eq 127
684 then
03aa3783 685 echo >&4 "test_must_fail: command not found: $*"
12a29b1a 686 return 1
bbfe5302
LS
687 elif test $exit_code -eq 126
688 then
03aa3783 689 echo >&4 "test_must_fail: valgrind error: $*"
eeb69131 690 return 1
12a29b1a
TR
691 fi
692 return 0
a5bf824f 693} 7>&2 2>&4
12a29b1a
TR
694
695# Similar to test_must_fail, but tolerates success, too. This is
696# meant to be used in contexts like:
697#
698# test_expect_success 'some command works without configuration' '
699# test_might_fail git config --unset all.configuration &&
700# do something
701# '
702#
703# Writing "git config --unset all.configuration || :" would be wrong,
704# because we want to notice if it fails due to segv.
12e31a6b
SG
705#
706# Accepts the same options as test_must_fail.
12a29b1a
TR
707
708test_might_fail () {
a5bf824f
SG
709 test_must_fail ok=success "$@" 2>&7
710} 7>&2 2>&4
12a29b1a
TR
711
712# Similar to test_must_fail and test_might_fail, but check that a
713# given command exited with a given exit code. Meant to be used as:
714#
715# test_expect_success 'Merge with d/f conflicts' '
716# test_expect_code 1 git merge "merge msg" B master
717# '
718
719test_expect_code () {
720 want_code=$1
721 shift
a5bf824f 722 "$@" 2>&7
12a29b1a
TR
723 exit_code=$?
724 if test $exit_code = $want_code
725 then
726 return 0
727 fi
728
03aa3783 729 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
12a29b1a 730 return 1
a5bf824f 731} 7>&2 2>&4
12a29b1a
TR
732
733# test_cmp is a helper function to compare actual and expected output.
734# You can use it like:
735#
736# test_expect_success 'foo works' '
737# echo expected >expected &&
738# foo >actual &&
739# test_cmp expected actual
740# '
741#
742# This could be written as either "cmp" or "diff -u", but:
743# - cmp's output is not nearly as easy to read as diff -u
744# - not all diff versions understand "-u"
745
746test_cmp() {
747 $GIT_TEST_CMP "$@"
748}
749
a5db0b77
NTND
750# Check that the given config key has the expected value.
751#
752# test_cmp_config [-C <dir>] <expected-value>
753# [<git-config-options>...] <config-key>
754#
755# for example to check that the value of core.bar is foo
756#
757# test_cmp_config foo core.bar
758#
759test_cmp_config() {
760 local GD &&
761 if test "$1" = "-C"
762 then
763 shift &&
764 GD="-C $1" &&
765 shift
766 fi &&
767 printf "%s\n" "$1" >expect.config &&
768 shift &&
769 git $GD config "$@" >actual.config &&
770 test_cmp expect.config actual.config
771}
772
b93e6e36
SK
773# test_cmp_bin - helper to compare binary files
774
775test_cmp_bin() {
776 cmp "$@"
777}
778
0f59128f
SG
779# Use this instead of test_cmp to compare files that contain expected and
780# actual output from git commands that can be translated. When running
6cdccfce 781# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
0f59128f
SG
782# results.
783test_i18ncmp () {
6cdccfce 784 ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
0f59128f
SG
785}
786
787# Use this instead of "grep expected-string actual" to see if the
788# output from a git command that can be translated either contains an
789# expected string, or does not contain an unwanted one. When running
6cdccfce 790# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
0f59128f
SG
791# results.
792test_i18ngrep () {
fd29d7b9
SG
793 eval "last_arg=\${$#}"
794
795 test -f "$last_arg" ||
165293af 796 BUG "test_i18ngrep requires a file to read as the last parameter"
fd29d7b9
SG
797
798 if test $# -lt 2 ||
799 { test "x!" = "x$1" && test $# -lt 3 ; }
800 then
165293af 801 BUG "too few parameters to test_i18ngrep"
fd29d7b9
SG
802 fi
803
6cdccfce 804 if test_have_prereq !C_LOCALE_OUTPUT
0f59128f 805 then
63b1a175
SG
806 # pretend success
807 return 0
808 fi
809
810 if test "x!" = "x$1"
0f59128f
SG
811 then
812 shift
63b1a175
SG
813 ! grep "$@" && return 0
814
03aa3783 815 echo >&4 "error: '! grep $@' did find a match in:"
0f59128f 816 else
63b1a175
SG
817 grep "$@" && return 0
818
03aa3783 819 echo >&4 "error: 'grep $@' didn't find a match in:"
0f59128f 820 fi
63b1a175
SG
821
822 if test -s "$last_arg"
823 then
03aa3783 824 cat >&4 "$last_arg"
63b1a175 825 else
03aa3783 826 echo >&4 "<File '$last_arg' is empty>"
63b1a175
SG
827 fi
828
829 return 1
0f59128f
SG
830}
831
8ad16524
JK
832# Call any command "$@" but be more verbose about its
833# failure. This is handy for commands like "test" which do
834# not output anything when they fail.
835verbose () {
836 "$@" && return 0
03aa3783 837 echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
8ad16524
JK
838 return 1
839}
840
ca8d148d
JH
841# Check if the file expected to be empty is indeed empty, and barfs
842# otherwise.
843
844test_must_be_empty () {
9eb23080
SG
845 test_path_is_file "$1" &&
846 if test -s "$1"
ca8d148d
JH
847 then
848 echo "'$1' is not empty, it contains:"
849 cat "$1"
850 return 1
851 fi
852}
853
5d77298d
MZ
854# Tests that its two parameters refer to the same revision
855test_cmp_rev () {
30d0b6dc
SG
856 if test $# != 2
857 then
858 error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
859 else
860 local r1 r2
861 r1=$(git rev-parse --verify "$1") &&
862 r2=$(git rev-parse --verify "$2") &&
863 if test "$r1" != "$r2"
864 then
865 cat >&4 <<-EOF
866 error: two revisions point to different objects:
867 '$1': $r1
868 '$2': $r2
869 EOF
870 return 1
871 fi
872 fi
5d77298d
MZ
873}
874
55672a39
JH
875# Print a sequence of integers in increasing order, either with
876# two arguments (start and end):
d17cf5f3 877#
55672a39
JH
878# test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
879#
880# or with one argument (end), in which case it starts counting
881# from 1.
d17cf5f3
MK
882
883test_seq () {
884 case $# in
885 1) set 1 "$@" ;;
886 2) ;;
165293af 887 *) BUG "not 1 or 2 parameters to test_seq" ;;
d17cf5f3 888 esac
4df43135
JH
889 test_seq_counter__=$1
890 while test "$test_seq_counter__" -le "$2"
891 do
892 echo "$test_seq_counter__"
893 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
894 done
d17cf5f3
MK
895}
896
12a29b1a
TR
897# This function can be used to schedule some commands to be run
898# unconditionally at the end of the test to restore sanity:
899#
900# test_expect_success 'test core.capslock' '
901# git config core.capslock true &&
902# test_when_finished "git config --unset core.capslock" &&
903# hello world
904# '
905#
906# That would be roughly equivalent to
907#
908# test_expect_success 'test core.capslock' '
909# git config core.capslock true &&
910# hello world
911# git config --unset core.capslock
912# '
913#
914# except that the greeting and config --unset must both succeed for
915# the test to pass.
916#
917# Note that under --immediate mode, no clean-up is done to help diagnose
918# what went wrong.
919
920test_when_finished () {
0968f12a
JK
921 # We cannot detect when we are in a subshell in general, but by
922 # doing so on Bash is better than nothing (the test will
923 # silently pass on other shells).
924 test "${BASH_SUBSHELL-0}" = 0 ||
165293af 925 BUG "test_when_finished does nothing in a subshell"
12a29b1a
TR
926 test_cleanup="{ $*
927 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
928}
929
930# Most tests can use the created repository, but some may need to create more.
931# Usage: test_create_repo <directory>
932test_create_repo () {
933 test "$#" = 1 ||
165293af 934 BUG "not 1 parameter to test-create-repo"
12a29b1a
TR
935 repo="$1"
936 mkdir -p "$repo"
937 (
938 cd "$repo" || error "Cannot setup test environment"
8abfdf44 939 "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" init \
3af4c715 940 "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
12a29b1a
TR
941 error "cannot run git init -- have you built things yet?"
942 mv .git/hooks .git/hooks-disabled
943 ) || exit
944}
9ce415d9
JS
945
946# This function helps on symlink challenged file systems when it is not
947# important that the file system entry is a symbolic link.
948# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
949# symbolic link entry y to the index.
950
951test_ln_s_add () {
952 if test_have_prereq SYMLINKS
953 then
954 ln -s "$1" "$2" &&
955 git update-index --add "$2"
956 else
957 printf '%s' "$1" >"$2" &&
958 ln_s_obj=$(git hash-object -w "$2") &&
817d03e1
JS
959 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
960 # pick up stat info from the file
961 git update-index "$2"
9ce415d9
JS
962 fi
963}
4d715ac0 964
ac9afcc3
MT
965# This function writes out its parameters, one per line
966test_write_lines () {
967 printf "%s\n" "$@"
968}
969
a0e0ec9f 970perl () {
a5bf824f
SG
971 command "$PERL_PATH" "$@" 2>&7
972} 7>&2 2>&4
a3a9cff0 973
83d842dc
JK
974# Is the value one of the various ways to spell a boolean true/false?
975test_normalize_bool () {
976 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
977}
978
979# Given a variable $1, normalize the value of it to one of "true",
980# "false", or "auto" and store the result to it.
981#
982# test_tristate GIT_TEST_HTTPD
983#
984# A variable set to an empty string is set to 'false'.
985# A variable set to 'false' or 'auto' keeps its value.
986# Anything else is set to 'true'.
987# An unset variable defaults to 'auto'.
988#
989# The last rule is to allow people to set the variable to an empty
990# string and export it to decline testing the particular feature
991# for versions both before and after this change. We used to treat
992# both unset and empty variable as a signal for "do not test" and
993# took any non-empty string as "please test".
994
995test_tristate () {
996 if eval "test x\"\${$1+isset}\" = xisset"
997 then
998 # explicitly set
999 eval "
1000 case \"\$$1\" in
1001 '') $1=false ;;
1002 auto) ;;
1003 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
1004 esac
1005 "
1006 else
1007 eval "$1=auto"
1008 fi
1009}
1010
1011# Exit the test suite, either by skipping all remaining tests or by
1012# exiting with an error. If "$1" is "auto", we then we assume we were
1013# opportunistically trying to set up some tests and we skip. If it is
1014# "true", then we report a failure.
1015#
1016# The error/skip message should be given by $2.
1017#
1018test_skip_or_die () {
1019 case "$1" in
1020 auto)
1021 skip_all=$2
1022 test_done
1023 ;;
1024 true)
1025 error "$2"
1026 ;;
1027 *)
1028 error "BUG: test tristate is '$1' (real error: $2)"
1029 esac
1030}
1031
4d715ac0
JS
1032# The following mingw_* functions obey POSIX shell syntax, but are actually
1033# bash scripts, and are meant to be used only with bash on Windows.
1034
1035# A test_cmp function that treats LF and CRLF equal and avoids to fork
1036# diff when possible.
1037mingw_test_cmp () {
1038 # Read text into shell variables and compare them. If the results
1039 # are different, use regular diff to report the difference.
1040 local test_cmp_a= test_cmp_b=
1041
1042 # When text came from stdin (one argument is '-') we must feed it
1043 # to diff.
1044 local stdin_for_diff=
1045
1046 # Since it is difficult to detect the difference between an
1047 # empty input file and a failure to read the files, we go straight
1048 # to diff if one of the inputs is empty.
1049 if test -s "$1" && test -s "$2"
1050 then
1051 # regular case: both files non-empty
1052 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1053 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1054 elif test -s "$1" && test "$2" = -
1055 then
1056 # read 2nd file from stdin
1057 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1058 mingw_read_file_strip_cr_ test_cmp_b
1059 stdin_for_diff='<<<"$test_cmp_b"'
1060 elif test "$1" = - && test -s "$2"
1061 then
1062 # read 1st file from stdin
1063 mingw_read_file_strip_cr_ test_cmp_a
1064 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1065 stdin_for_diff='<<<"$test_cmp_a"'
1066 fi
1067 test -n "$test_cmp_a" &&
1068 test -n "$test_cmp_b" &&
1069 test "$test_cmp_a" = "$test_cmp_b" ||
1070 eval "diff -u \"\$@\" $stdin_for_diff"
1071}
1072
1073# $1 is the name of the shell variable to fill in
1074mingw_read_file_strip_cr_ () {
1075 # Read line-wise using LF as the line separator
1076 # and use IFS to strip CR.
1077 local line
1078 while :
1079 do
1080 if IFS=$'\r' read -r -d $'\n' line
1081 then
1082 # good
1083 line=$line$'\n'
1084 else
1085 # we get here at EOF, but also if the last line
1086 # was not terminated by LF; in the latter case,
1087 # some text was read
1088 if test -z "$line"
1089 then
1090 # EOF, really
1091 break
1092 fi
1093 fi
1094 eval "$1=\$$1\$line"
1095 done
1096}
d2554c72
JK
1097
1098# Like "env FOO=BAR some-program", but run inside a subshell, which means
1099# it also works for shell functions (though those functions cannot impact
1100# the environment outside of the test_env invocation).
1101test_env () {
1102 (
1103 while test $# -gt 0
1104 do
1105 case "$1" in
1106 *=*)
1107 eval "${1%%=*}=\${1#*=}"
1108 eval "export ${1%%=*}"
1109 shift
1110 ;;
1111 *)
a5bf824f 1112 "$@" 2>&7
d2554c72
JK
1113 exit
1114 ;;
1115 esac
1116 done
1117 )
a5bf824f 1118} 7>&2 2>&4
48860819 1119
9b67c994
JK
1120# Returns true if the numeric exit code in "$2" represents the expected signal
1121# in "$1". Signals should be given numerically.
1122test_match_signal () {
1123 if test "$2" = "$((128 + $1))"
1124 then
1125 # POSIX
1126 return 0
1127 elif test "$2" = "$((256 + $1))"
1128 then
1129 # ksh
1130 return 0
1131 fi
1132 return 1
1133}
39cadeec 1134
48860819
JK
1135# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1136test_copy_bytes () {
1137 perl -e '
1138 my $len = $ARGV[1];
1139 while ($len > 0) {
1140 my $s;
1141 my $nread = sysread(STDIN, $s, $len);
1142 die "cannot read: $!" unless defined($nread);
f7f6dc34 1143 last unless $nread;
48860819
JK
1144 print $s;
1145 $len -= $nread;
1146 }
1147 ' - "$1"
1148}
de95302a
JK
1149
1150# run "$@" inside a non-git directory
1151nongit () {
1152 test -d non-repo ||
1153 mkdir non-repo ||
1154 return 1
1155
1156 (
1157 GIT_CEILING_DIRECTORIES=$(pwd) &&
1158 export GIT_CEILING_DIRECTORIES &&
1159 cd non-repo &&
a5bf824f 1160 "$@" 2>&7
de95302a 1161 )
a5bf824f 1162} 7>&2 2>&4
4414a150
JK
1163
1164# convert stdin to pktline representation; note that empty input becomes an
1165# empty packet, not a flush packet (for that you can just print 0000 yourself).
1166packetize() {
1167 cat >packetize.tmp &&
1168 len=$(wc -c <packetize.tmp) &&
1169 printf '%04x%s' "$(($len + 4))" &&
1170 cat packetize.tmp &&
1171 rm -f packetize.tmp
1172}
1173
1174# Parse the input as a series of pktlines, writing the result to stdout.
1175# Sideband markers are removed automatically, and the output is routed to
1176# stderr if appropriate.
1177#
1178# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1179depacketize () {
1180 perl -e '
1181 while (read(STDIN, $len, 4) == 4) {
1182 if ($len eq "0000") {
1183 print "FLUSH\n";
1184 } else {
1185 read(STDIN, $buf, hex($len) - 4);
1186 $buf =~ s/\0/\\0/g;
1187 if ($buf =~ s/^[\x2\x3]//) {
1188 print STDERR $buf;
1189 } else {
1190 $buf =~ s/^\x1//;
1191 print $buf;
1192 }
1193 }
1194 }
1195 '
1196}
2c02b110 1197
1198# Set the hash algorithm in use to $1. Only useful when testing the testsuite.
1199test_set_hash () {
1200 test_hash_algo="$1"
1201}
1202
1203# Detect the hash algorithm in use.
1204test_detect_hash () {
1205 # Currently we only support SHA-1, but in the future this function will
1206 # actually detect the algorithm in use.
1207 test_hash_algo='sha1'
1208}
1209
1210# Load common hash metadata and common placeholder object IDs for use with
1211# test_oid.
1212test_oid_init () {
1213 test -n "$test_hash_algo" || test_detect_hash &&
1214 test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1215 test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1216}
1217
1218# Load key-value pairs from stdin suitable for use with test_oid. Blank lines
1219# and lines starting with "#" are ignored. Keys must be shell identifier
1220# characters.
1221#
1222# Examples:
1223# rawsz sha1:20
1224# rawsz sha256:32
1225test_oid_cache () {
1226 local tag rest k v &&
1227
1228 { test -n "$test_hash_algo" || test_detect_hash; } &&
1229 while read tag rest
1230 do
1231 case $tag in
1232 \#*)
1233 continue;;
1234 ?*)
1235 # non-empty
1236 ;;
1237 *)
1238 # blank line
1239 continue;;
1240 esac &&
1241
1242 k="${rest%:*}" &&
1243 v="${rest#*:}" &&
1244
1245 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1246 then
165293af 1247 BUG 'bad hash algorithm'
2c02b110 1248 fi &&
1249 eval "test_oid_${k}_$tag=\"\$v\""
1250 done
1251}
1252
1253# Look up a per-hash value based on a key ($1). The value must have been loaded
1254# by test_oid_init or test_oid_cache.
1255test_oid () {
1256 local var="test_oid_${test_hash_algo}_$1" &&
1257
1258 # If the variable is unset, we must be missing an entry for this
1259 # key-hash pair, so exit with an error.
1260 if eval "test -z \"\${$var+set}\""
1261 then
165293af 1262 BUG "undefined key '$1'"
2c02b110 1263 fi &&
1264 eval "printf '%s' \"\${$var}\""
1265}
fa840581
SG
1266
1267# Choose a port number based on the test script's number and store it in
1268# the given variable name, unless that variable already contains a number.
1269test_set_port () {
1270 local var=$1 port
1271
1272 if test $# -ne 1 || test -z "$var"
1273 then
1274 BUG "test_set_port requires a variable name"
1275 fi
1276
1277 eval port=\$$var
1278 case "$port" in
1279 "")
1280 # No port is set in the given env var, use the test
1281 # number as port number instead.
1282 # Remove not only the leading 't', but all leading zeros
1283 # as well, so the arithmetic below won't (mis)interpret
1284 # a test number like '0123' as an octal value.
1285 port=${this_test#${this_test%%[1-9]*}}
1286 if test "${port:-0}" -lt 1024
1287 then
1288 # root-only port, use a larger one instead.
1289 port=$(($port + 10000))
1290 fi
1291
1292 eval $var=$port
1293 ;;
1294 *[^0-9]*|0*)
1295 error >&7 "invalid port number: $port"
1296 ;;
1297 *)
1298 # The user has specified the port.
1299 ;;
1300 esac
1301}